# Interface SettingStoreFactory

All Known Implementing Classes:
  `FileSettingStoreFactory`

public interface SettingStoreFactory
A setting store factory is responsible for creating and initializing a specific kind of setting store. To contribute a custom setting store implementation, an implementation of this interface must be provided in an `ApplicationConfiguration` (see `Application.setSettingStoreFactory(SettingStoreFactory)`).

At runtime, the framework will use a single factory implementation to create new setting store instances. If no custom factory is specified, the `FileSettingStoreFactory` will be used as default.

Since:
  2.0
See Also:
  - `Application.setSettingStoreFactory(SettingStoreFactory)`

## Method Summary

Modifier and Type
Method
Description
`SettingStore`
`createSettingStore(String id)`
Creates and initializes a new specific setting store instance.

## Method Details

### createSettingStore

SettingStore createSettingStore(String id)
Creates and initializes a new specific setting store instance.

Parameters:
  `id` - the ID for the setting store to create, must not be `null` or empty
Returns:
  the created setting store, never `null`
Throws:
  `IllegalArgumentException` - if the given id is empty